/*******************************************************************************
 * File:		FILE
 * Module:		MODULE
 * Author:		AUTHOR
 * Date:		DATE
 * 
 * Notes:
 *
 * $Id$
 *
 * History:
 * $Log$
 *
 ******************************************************************************/


#include <stdio.h>

typedef unsigned short u16;

#include "crc10.c"
#include "crc10.h"

#define PAYLOAD_SIZE 48

static unsigned char test_cell_1_payload[PAYLOAD_SIZE+2]={
        0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

static unsigned char test_cell_2_payload[PAYLOAD_SIZE+2]={
        0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,
        0x11, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

static unsigned char test_cell_3_payload[PAYLOAD_SIZE+2]={
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00};

static unsigned char test_cell_4_payload[PAYLOAD_SIZE+2]={
        0x12, 0x34, 0x56, 0x78, 0x90, 0x12, 0x34, 0x56,
        0x78, 0x90, 0x12, 0x34, 0x56, 0x78, 0x90, 0x12,
        0x34, 0x56, 0x78, 0x90, 0x12, 0x34, 0x56, 0x78,
        0x90, 0x12, 0x34, 0x56, 0x78, 0x90, 0x12, 0x34,
        0x56, 0x78, 0x90, 0x12, 0x34, 0x56, 0x78, 0x90,
        0x12, 0x34, 0x56, 0x78, 0x90, 0x12, 0x00, 0x00};

static unsigned char ais_cell_payload[PAYLOAD_SIZE+2]={
        0x10, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x00, 0x00};

static unsigned char rdi_cell_payload[PAYLOAD_SIZE+2]={
        0x11, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x00, 0x00};

static unsigned char loopback_cell_payload[PAYLOAD_SIZE+2]={
        0x18, 0x01, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
        0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x6a,
        0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x6a, 0x00, 0x00};

static unsigned char testA[4] = {
    0x61, 0x00, 0x00, 0x00 };

static unsigned char testB[4] = {
    0x0d, 0x00, 0x00, 0x00 };

test1(unsigned char *cp, int l)
{
    unsigned char buf[64];
    int i;

    u16 fcs;

    memcpy(buf, cp, l-2);

    buf[l-2] = (l - 2) << 2;
    buf[l-1] = '\0';

    for (i = 0; i < l; i++) {
        if ((i%16)==0) {
            printf("\n");
        }
        printf("%02x ", buf[i]);
    }
    printf("\n");

    fcs = fcs_compute10(buf, l, CRC10_INITFCS);
    
    buf[l-2] |= (fcs >> 8);
    buf[l-1] |= fcs & 0xff;

    for (i = 0; i < l; i++) {
        if ((i%16)==0) {
            printf("\n");
        }
        printf("%02x ", buf[i]);
    }
    printf("\n");

    if ((fcs = fcs_compute10(buf, l, CRC10_INITFCS)) != CRC10_GOODFCS) {
        printf("fcs: %03x\n", fcs);
    }
}


int main(int argc, char **argv)
{

    int i;
    int l;

    test1(test_cell_1_payload, PAYLOAD_SIZE);
    test1(test_cell_2_payload, PAYLOAD_SIZE);
    test1(test_cell_3_payload, PAYLOAD_SIZE);
    test1(test_cell_4_payload, PAYLOAD_SIZE);
    test1(ais_cell_payload, PAYLOAD_SIZE);
    test1(rdi_cell_payload, PAYLOAD_SIZE);
    test1(loopback_cell_payload, PAYLOAD_SIZE);
    test1(testA, 3);
    test1(testB, 3);

}






/* End of FILE */
